| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Private Attributes | List of all members
Gaudi::MetaDataSvc Class Reference

`#include <src/MetaDataSvc/MetaDataSvc.h>`

Inheritance diagram for Gaudi::MetaDataSvc:
[legend]
Collaboration diagram for Gaudi::MetaDataSvc:
[legend]

## Public Member Functions
StatusCode | start () override
bool | isEnabled () const
StatusCode | collectData ()
std::map< std::string, std::string > | getMetaDataMap () const override
Public Member Functions inherited from extends< Service, IMetaDataSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Private Attributes
Gaudi::Property< bool > | m_isEnabled {this, "Enabled", true}
std::map< std::string, std::string > | m_metadata

## Additional Inherited Members
Public Types inherited from extends< Service, IMetaDataSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 15 of file MetaDataSvc.h.

## Member Function Documentation

## ◆ collectData()

StatusCode MetaDataSvc::collectData | ( |  | ) |

Definition at line 56 of file MetaDataSvc.cpp.

56 {
57
58 // save options for all clients
59 {
60 auto joSvc = service<IJobOptionsSvc>( "JobOptionsSvc" );
61 if ( !joSvc.isValid() ) return StatusCode::FAILURE;
62 for ( const auto c : joSvc->getClients() ) {
63 // get options for this client
64 const auto props = joSvc->getProperties( c );
65 if ( props ) {
66 for ( const auto prop : *props ) { m_metadata[c + "." + prop->name()] = prop->toString(); }
67 }
68 }
69 }
70
71 for ( const auto* name : {"ApplicationMgr", "MessageSvc", "NTupleSvc"} ) {
72 auto svc = service<IProperty>( name );
73 if ( !svc.isValid() ) continue;
74 const auto prefix = name + std::string{"."};
75 for ( const auto* prop : svc->getProperties() ) { m_metadata[prefix + prop->name()] = prop->toString(); }
76 }
77
78 /*
79 * TOOLS
80 * */
81 SmartIF<IToolSvc> tSvc( serviceLocator()->service( "ToolSvc" ) );
82 if ( tSvc.isValid() ) { m_metadata["ToolSvc"] = join( tSvc->getInstances( "" ), ", " ); }
83
84 /*
85 * SERVICES
86 * */
87 m_metadata["ISvcLocator.Services"] = join( serviceLocator()->getServices(), ", ", get_name );
88
89 /*
90 * ALGORITHMS
91 * */
92 SmartIF<IAlgManager> algMan( serviceLocator() );
93 m_metadata["IAlgManager.Algorithms"] = join( algMan->getAlgorithms(), ", ", get_name );
94
95 /*
96 * JOB OPTIONS SERVICE
97 * */
98 {
99 auto joSvc = service<IProperty>( "JobOptionsSvc" );
100 if ( !joSvc.isValid() ) return StatusCode::FAILURE;
101 for ( const auto* prop : joSvc->getProperties() ) {
102 m_metadata["JobOptionsSvc." + prop->name()] = prop->toString();
103 }
104 }
105
106 if ( msgLevel( MSG::DEBUG ) ) {
107 debug() << "Metadata collected:\n";
108 for ( const auto& item : m_metadata ) { debug() << item.first << ':' << item.second << '\n'; }
109 debug() << endmsg;
110 }
111
112 return StatusCode::SUCCESS;
113 }
SmartIF< IToolSvc >
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:277
gaudirun.c
c
Definition: gaudirun.py:487
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
CommonMessaging< implements< IService, IProperty, IStateful > >::msgLevel
MSG::Level msgLevel() const
get the cached level (originally extracted from the embedded MsgStream)
Definition: CommonMessaging.h:138
std::string
STL class.
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
gaudirun.prefix
string prefix
Definition: gaudirun.py:331
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
Service::service
StatusCode service(const std::string &name, const T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn't already exist.
Definition: Service.h:83
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
Gaudi::MetaDataSvc::m_metadata
std::map< std::string, std::string > m_metadata
Definition: MetaDataSvc.h:30

## ◆ getMetaDataMap()

std::map< std::string, std::string > MetaDataSvc::getMetaDataMap | ( |  | ) | const
| override

Definition at line 54 of file MetaDataSvc.cpp.

54 { return m_metadata; }
Gaudi::MetaDataSvc::m_metadata
std::map< std::string, std::string > m_metadata
Definition: MetaDataSvc.h:30

## ◆ isEnabled()

bool Gaudi::MetaDataSvc::isEnabled | ( |  | ) | const
| inline

Definition at line 21 of file MetaDataSvc.h.

21 { return m_isEnabled; }
Gaudi::MetaDataSvc::m_isEnabled
Gaudi::Property< bool > m_isEnabled
Definition: MetaDataSvc.h:28

## ◆ start()

StatusCode MetaDataSvc::start | ( |  | ) |
| override

Definition at line 49 of file MetaDataSvc.cpp.

49 {
50 if ( msgLevel( MSG::DEBUG ) ) debug() << "started" << endmsg;
51 return collectData();
52 }
MSG::DEBUG
Definition: IMessageSvc.h:15
CommonMessaging< implements< IService, IProperty, IStateful > >::msgLevel
MSG::Level msgLevel() const
get the cached level (originally extracted from the embedded MsgStream)
Definition: CommonMessaging.h:138
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
Gaudi::MetaDataSvc::collectData
StatusCode collectData()
Definition: MetaDataSvc.cpp:56

## Member Data Documentation

## ◆ m_isEnabled

Gaudi::Property<bool> Gaudi::MetaDataSvc::m_isEnabled {this, "Enabled", true}
| private

Definition at line 28 of file MetaDataSvc.h.

## ◆ m_metadata

std::map<std::string, std::string> Gaudi::MetaDataSvc::m_metadata
| private

Definition at line 30 of file MetaDataSvc.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/MetaDataSvc/MetaDataSvc.h
- GaudiSvc/src/MetaDataSvc/MetaDataSvc.cpp